#ifndef __MLVIEW_XML_DOCUMENT_VIEW_H__
#define __MLVIEW_XML_DOCUMENT_VIEW_H__

#include <gnome.h>
#include "mlview-app-context.h"
#include "mlview-xml-document.h"

#ifdef __cplusplus
extern "C" {
#endif /*__cplusplus*/
/************************************************
 *This class is only the base class of all the 
 *views of an MlViewXMLDocument.
 ************************************************/

#define MLVIEW_TYPE_XML_DOCUMENT_VIEW (mlview_xml_document_view_get_type ())
#define MLVIEW_XML_DOCUMENT_VIEW(object) (GTK_CHECK_CAST ((object), MLVIEW_TYPE_XML_DOCUMENT_VIEW, MlViewXMLDocumentView))
#define MLVIEW_XML_DOCUMENT_VIEW_CLASS(object) (GTK_CHECK_CLASS_CAST ((klass), MVLIEW_TYPE_XML_DOCUMENT_VIEW, MlViewXMLDocumentViewClass))
#define MLVIEW_IS_XML_DOCUMENT_VIEW(object) (GTK_CHECK_TYPE ((object), MLVIEW_TYPE_XML_DOCUMENT_VIEW))
#define MLVIEW_IS_XML_DOCUMENT_VIEW_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), MLVIEW_TYPE_XML_DOCUMENT_VIEW))

	typedef struct _MlViewXMLDocumentView MlViewXMLDocumentView ;
	typedef struct _MlViewXMLDocumentViewClass MlViewXMLDocumentViewClass ;
	typedef struct _MlViewXMLDocumentViewPrivate MlViewXMLDocumentViewPrivate ;

	struct _SignalCallbackDescriptor {
		gchar * signal_name ;
		GtkSignalFunc  signal_handler ;
	} ;
	typedef struct _SignalCallbackDescriptor SignalCallbackDescriptor ;

	enum MLVIEW_XML_DOCUMENT_VIEW_STATUS {
		MLVIEW_XML_DOCUMENT_VIEW_OK,
		MLVIEW_XML_DOCUMENT_VIEW_NOK,
		MLVIEW_XML_DOCUMENT_VIEW_DOC_SIGNAL_HANDLERS_NOT_SET,
		MLVIEW_XML_DOCUMENT_VIEW_BAD_PARAMETER
	} ;

	struct _MlViewXMLDocumentView {
		GtkVBox box ;
		MlViewXMLDocumentViewPrivate *private ;
	};

	struct _MlViewXMLDocumentViewClass {
		GtkVBoxClass parent_class ;

		/*Document view signals*/
		void (*name_changed) (MlViewXMLDocumentView *a_view,
				      gpointer a_user_data) ;
	} ;

	gint 
	mlview_xml_document_view_get_type (void) ;

	enum MLVIEW_XML_DOCUMENT_VIEW_STATUS
	mlview_xml_document_view_construct (MlViewXMLDocumentView * a_doc_view,
					    MlViewXMLDocument *a_mlview_xml_doc) ;
	
	MlViewXMLDocumentView *
	mlview_xml_document_view_new (MlViewXMLDocument *a_mlview_doc) ;

	void
	mlview_xml_document_view_set_document_signal_handlers (SignalCallbackDescriptor *a_signals) ;
	
	void 
	mlview_xml_document_view_set_name (MlViewXMLDocumentView *a_view, 
					   gchar *a_name) ;

	void
	mlview_xml_document_view_set_name_interactive (MlViewXMLDocumentView * a_view) ;

	gchar * 
	mlview_xml_document_view_get_name (MlViewXMLDocumentView *a_view) ;

	MlViewXMLDocument * 
	mlview_xml_document_view_get_document (MlViewXMLDocumentView *a_doc_view) ;

	void 
	mlview_xml_document_view_set_document (MlViewXMLDocumentView *a_doc_view,
						    MlViewXMLDocument * a_mlview_doc) ;	

	MlViewFileDescriptor * 
	mlview_xml_document_view_get_file_descriptor (MlViewXMLDocumentView * a_doc_view) ;

	void  
	mlview_xml_document_view_destroy (GtkObject *a_mlview_xml_doc_view) ;

#ifdef __cplusplus
}

#endif /*__cplusplus*/
#endif /*__MLVIEW_XML_DOCUMENT_VIEW_H__*/
